#include <windows.h>

#include "/BSC/FString.h"
#include "/BSC/FArray.h"
#include "/BSC/ResStr.h"

#include "resource.h"

HINSTANCE hInst;

HWND hList, hBtnUp, hBtnDown;
FArray<FString> aIME;

FString sAppName;

void onInit(HWND hDlg)
{
    //Ϊͼ
    HICON hIcon;

    hIcon=(HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
    DefDlgProc(hDlg, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
    hIcon=(HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
    DefDlgProc(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);

    hIcon=LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_UP));
    SendMessage((hBtnUp=GetDlgItem(hDlg, IDC_BTN_UP)), BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);

    hIcon=LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_DOWN));
    SendMessage((hBtnDown=GetDlgItem(hDlg, IDC_BTN_DOWN)), BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);

    hList=GetDlgItem(hDlg, IDC_LIST);
    int i=2;

    HKEY myKey;
    FString szKeyValue;
    unsigned long size=1024;
    int err;

    do
    {
        szKeyValue.buffer(200);
        wsprintf(szKeyValue, ".DEFAULT\\keyboard layout\\preload\\%i", i);

        if(RegOpenKeyEx(HKEY_USERS, szKeyValue, 0, KEY_READ, &myKey)!=ERROR_SUCCESS)
            break;

        unsigned long size=1024;
        szKeyValue.buffer(1024);
        err=RegQueryValueEx(myKey, NULL, 0, NULL, (unsigned char *)szKeyValue.GetData(), &size);
        RegCloseKey(myKey);

        if(err==ERROR_SUCCESS)
        {
            aIME.Add(szKeyValue);
            if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, FString("System\\CurrentControlSet\\Control\\Keyboard Layouts\\")+szKeyValue, 0, KEY_READ, &myKey)!=ERROR_SUCCESS)
                break;

            size=1024;
            szKeyValue.buffer(1024);
            err=RegQueryValueEx(myKey, "layout text", 0, NULL, (unsigned char *)szKeyValue.GetData(), &size);
            RegCloseKey(myKey);

            if(err==ERROR_SUCCESS)
                SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)(char *)szKeyValue);
            else
                aIME.Delete(aIME.GetCount()-1);
        }

        i++;
    }
    while(err==ERROR_SUCCESS);
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    FString buffer;
    int nSel;
    unsigned int i;

    switch(uMsg)
    {
    case WM_INITDIALOG:
        onInit(hDlg);
        return TRUE;
    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDC_LIST:
            if(HIWORD(wParam)==LBN_SELCHANGE)
            {
                nSel=SendMessage(hList, LB_GETCURSEL, 0, 0);
                int nCount=SendMessage(hList, LB_GETCOUNT, 0, 0);

                if(nSel>0)
                    EnableWindow(hBtnUp, TRUE);
                else
                    EnableWindow(hBtnUp, FALSE);

                if(nSel<nCount-1)
                    EnableWindow(hBtnDown, TRUE);
                else
                    EnableWindow(hBtnDown, FALSE);
            }   
            break;
        case IDC_BTN_UP:
            buffer.buffer(1024);
            nSel=SendMessage(hList, LB_GETCURSEL, 0, 0);
            SendMessage(hList, LB_GETTEXT, nSel, (LPARAM)(char *)buffer);
            SendMessage(hList, LB_DELETESTRING, nSel, 0);
            SendMessage(hList, LB_INSERTSTRING, nSel-1, (LPARAM)(char *)buffer);
            SendMessage(hList, LB_SETCURSEL, nSel-1, 0);
            SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_LIST, LBN_SELCHANGE), 0);

            aIME.Swap(nSel, nSel-1);

            break;
        case IDC_BTN_DOWN:
            buffer.buffer(1024);
            nSel=SendMessage(hList, LB_GETCURSEL, 0, 0);
            SendMessage(hList, LB_GETTEXT, nSel, (LPARAM)(char *)buffer);
            SendMessage(hList, LB_DELETESTRING, nSel, 0);
            SendMessage(hList, LB_INSERTSTRING, nSel+1, (LPARAM)(char *)buffer);
            SendMessage(hList, LB_SETCURSEL, nSel+1, 0);
            SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_LIST, LBN_SELCHANGE), 0);

            aIME.Swap(nSel, nSel+1);
            
            break;
        case IDOK:
            for(i=0; i<aIME.GetCount(); i++)
            {
                HKEY myKey;
                FString szKeyValue;
                unsigned long size=1024;
                int err;

                szKeyValue.buffer(200);
                wsprintf(szKeyValue, ".DEFAULT\\keyboard layout\\preload\\%i", i+2);

                if(RegOpenKeyEx(HKEY_USERS, szKeyValue, 0, KEY_READ, &myKey)!=ERROR_SUCCESS)
                    break;

                size=aIME[i].GetLength()+1;
                err=RegSetValueEx(myKey, NULL, 0, REG_SZ, (unsigned char *)(char *)aIME[i], size);
                RegCloseKey(myKey);

                if(err!=ERROR_SUCCESS)
                    break;
            }
            
            MessageBox(hDlg, String(IDS_RESTART, hInst), sAppName, MB_ICONINFORMATION);
        case IDCANCEL:
            EndDialog(hDlg, LOWORD(wParam));
            break;
        }
        break;
    }

    return FALSE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    sAppName=String(IDS_APPNAME, hInst=hInstance);
    DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG), NULL, DlgProc);
    return 0;
}